import java.util.Scanner;
import java.util.Arrays;

public class ShutTheBoxI {

    private static void solveShutTheBoxI(int[] values, int target) {
        boolean[] solution = new boolean[values.length];
        boolean solution_found = false;

        /* ------------------- INSERT CODE HERE ---------------------
         * 
         * Your code should set the values for the variables solution[] and solution_found
         * appropriately.
         *
         * solution_found should be set to true if there is a valid move.
         *
         * the boolean array "solution" should record the best move: if solution[i] = true, 
         * then the corresponding values[i] should be closed.
         *
         * */

        /* We will go over every possible combination, starting with the one that involves
         * largest value, and check whether the sum equals "target". If yes, we are
         * done. */

        boolean[] current = new boolean[values.length];

        for(int i = 0; i < current.length; i++)
            current[i] = false;

        boolean found = true;
        while(found) {
            /* From the end, find the first one that is false, and set it to true. */
            found = false;
            for(int i = current.length - 1; i >= 0; i--) {
                if(current[i]) {
                    current[i] = false;
                } else {
                    current[i] = true;
                    found = true;
                    break;
                }
            }

            // System.out.println(Arrays.toString(current));

            if(found) {
                int sum = 0;
                for(int i = current.length - 1; i >= 0; i--)
                    if(current[i])
                        sum += values[i];
                if(sum == target) {
                    // System.out.println(Arrays.toString(current) +  " is a solution");
                    solution = current;
                    solution_found = true;
                    break;
                }
            }
        }
            
        /* -------------------- END OF INSERTION --------------------*/

        if(!solution_found) {
            System.out.println("No move found.");
        } else {
            System.out.print("The best move is:");
            for(int i = 0; i < solution.length; i++)
                if(solution[i])
                    System.out.print(" " + values[i]);
            System.out.println();
        }
    }
    
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            int target = sc.nextInt();

            int numEntries = sc.nextInt();

            int[] values = new int[numEntries];

            for(int j = 0; j < values.length; j++)
                values[j] = sc.nextInt();

            solveShutTheBoxI(values, target);
        }
    }
}
