import java.util.Scanner;
import java.util.Vector;

public class VigenereII {

    private static Vector<Integer> solveVignereII(String cipherText) {
        Vector<Integer> ret = new Vector<Integer>();

        /* ------------------- INSERT CODE HERE --------------------- */

        Vector<Integer> v = new Vector<Integer>();

        /* We will just do a brute force search. */
        for(int i = 0; i < cipherText.length() - 2; i++) {
            for(int j = i + 1; j < cipherText.length() - 2; j++) {
                if(cipherText.charAt(i) == cipherText.charAt(j)) {
                    boolean b = true;
                    b = (b && (cipherText.charAt(i+1) == cipherText.charAt(j+1)));
                    b = (b && (cipherText.charAt(i+2) == cipherText.charAt(j+2)));

                    if(b) {
                        // System.out.println("Found " + cipherText.charAt(i) + cipherText.charAt(i+1) + cipherText.charAt(i+2));
                        // System.out.println("Adding " + (j - i));
                        v.add(new Integer(j - i));
                    }
                }
            }
        }

        /* Find the largest number that factors at least 90% of the lengths. */
        double total = (double) v.size();
        for(int i = 4; i <= 20; i++) {
            int count = 0;
            for(Integer ii: v) {
                if(ii.intValue() % i == 0) 
                    count++;
            }
            // System.out.println("For " + i + " count = " + count);
            if( (count * 1.0/total) > 0.9) {
                ret.add(new Integer(i));
            }
        }

        /* -------------------- END OF INSERTION --------------------*/

        return ret;
    }
    
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            String cipherText = sc.next();

            Vector<Integer> v = solveVignereII(cipherText);

            if(v.size() == 0) {
                System.out.println("No guesses found.");
            } else {
                System.out.print("Possible key lengths between 4 and 20:");
                for(Integer ii : v) {
                    System.out.print(" " + ii.intValue());
                }
                System.out.println();
            }
        }
    }
}
